# -*- coding: utf-8 -*-
"""
Created on Mon May 27 11:52:05 2019

@author: DEBERNARDI Christophe // chdebernardi@yahoo.fr - 06-63-43-79-83
chdebernardi.fr
"""


##############################################################################
# Documentations spécifiques                                                 #
## http://www.chicoree.fr/w/Fichiers_CSV_en_Python                           #
## https://patternformation.wordpress.com/2013/01/08/la-hauteur-des-arbres-2/#
##############################################################################

##############################################################################
# Fichier de travail                                                         #
#                                                                            #
# les-arbresTravailPython.csv     :  fichier csv : NON FRANCISE              #
#---------------  FICHIER EXCEL Mairie de Paris Open Data -------------------#
# https://opendata.paris.fr/explore/dataset/les-arbres/export/               #
##############################################################################

##############################################################################
# PREMIERE PARTIE                                                            #
# Objectif : Ouvrir et Extraire les informations utiles du fichier csv       #
# pour afficher le meme résultat que la version sans programme               #
#                                                                            #
# Quels sont les arbres de type platane présents sur le boulevard            #
# Saint Germain dans le 6ème arrondissement                                  #
##############################################################################

# plt.close("all")


import csv # Pour utiliser la classe csv et toutes les méthodes de cette classe
import matplotlib.pyplot as plt

# Ouverture SECURISEE du fichier à l'aide d'une structure with
with open('les-arbresTravailPython.csv') as fichier:

# Création d'un object de type lecture sur le fichier ; On donne le format du
# délimiteur (Pour le fichier les-arbresTravailPython.csv, le point virgule
# est le séparateur naturel) Cette information est disponible sur le site WEB
# https://opendata.paris.fr/explore/dataset/les-arbres/export/
    # Création d'un objet reader 
    ObjLectureCSV = csv.reader(fichier,delimiter=';') 
##########################################################################

# Note : le nom de la variable pour iterer sur le fichier par ligne est lignei
# Elle pourrait ne pas changer de nom mais j'ai fait le choix de changer de 
# variable à chaque parcours du fichier pour plus de clarté.    

# =============================================================================
# 
# Cet objet est itérable sur les lignes : On peut donc traduire 
# cette structure par : Pour toutes les lignes
    i=0
    for ligne1 in ObjLectureCSV :
        i=i+1
#        print (ligne1) # Affichage de tous les arbres de Paris 
                        # (A mettre en commentaire sinon très long)
    print (i) # Affichage du nombre d'arbres enregistrés dans la base
    
    fichier.seek(0) # Retour au début du fichier pour une nouvelle lecture 
                    # de celui-ci
    print ('--1--')
                    
# #############################################################################
# #### ATTENTION ### # ligne1 n'est pas réutiisable directement, il pointe
# #### désormais à l'exterieur du fichier (Il n'est pas remis remis au début du
# #### fichier) donc on ne peut pas faire deux parcours du meme fichier sans
# #### remettre l'objet ObjLectureCSV au début du fichier
# #############################################################################
 
    
# 
# # Cet objet est capable sur une ligne de chercher une "valeur" précise, 
# # donc en lisant le fichier excel, une cellule précise. 
# 
# (La colonne A est en position 0)
# Colonne A : Position 0   // IDBASE
# Colonne B : Position 1   // TYPEEMPLACEMENT
# Colonne C : Position 2   // DOMANIALITE
# Colonne D : Position 3   // ARRONDISSEMENT
# Colonne E : Position 4   // COMPLEMENTADRESSE
# Colonne F : Position 5   // NUMERO
# Colonne G : Position 6   // LIEU / ADRESSE
# Colonne H : Position 7   // IDEMPLACEMENT    
# Colonne I : Position 8   // LIBELLEFRANCAIS    
# Colonne J : Position 9   // GENRE
# Colonne K : Position 10  // ESPECE
# Colonne L : Position 11  // VARIETEOUCULTIVAR
# Colonne M : Position 12  // CIRCONFERENCEENCM
# Colonne N : Position 13  // HAUTEUR (m)
# Colonne O : Position 14  // STADEDEVELOPPEMENT     
# Colonne P : Position 15  // REMARQUABLE
# Colonne Q : Position 16  // geo_point_2d

# Les données sont des chaines

# Création des listes en relation avec les colonnes du fichier csv.     																
    IDBASE = []
    TYPEEMPLACEMENT = []
    DOMANIALITE = []
    ARRONDISSEMENT = []
    COMPLEMENTADRESSE = []
    NUMERO = []
    LIEU_ADRESSE = []
    IDEMPLACEMENT = []    
    LIBELLEFRANCAIS = []    
    GENRE = []
    ESPECE = []
    VARIETEOUCULTIVAR = []
    CIRCONFERENCEENCM = []
    HAUTEUR_m = []
    STADEDEVELOPPEMENT = []     
    REMARQUABLE = []
    geo_point_2d = []

# Création d'une liste de flottants. 
    HAUTEUR_mFloat = []
    
    for ligne2 in ObjLectureCSV : 
         #print (ligne2[13]) # Affichage d'une colonne en particulier 
                             # (la hauteur en m)
         HAUTEUR_m.append((ligne2[13])) # Création d'une liste avec la taille 
                                         # de tous les arbres

# Cast et extraction des données les plus abérrantes    
    HAUTEUR_mFloat.append(HAUTEUR_m[0]) # Ne pas prendre la première ligne car
    for i in range (1,len (HAUTEUR_m)): # elle contient le nom de la colonne
        tempHauteur=float(HAUTEUR_m[i]) # Cast en float pour obtenir 
                                        # des valeurs numeriques
        if tempHauteur>50: # Suppression des valeurs aberrantes
                           # 116 m : Arbre le plus grand du monde 
            tempHauteur=-1 # 50 m : Valeur aberrante en ville
        HAUTEUR_mFloat.append(tempHauteur)
    
    print ("L'arbre le plus haut mesure " , max(HAUTEUR_mFloat[1:])) # Prise 
# en compte de la liste après le premier element qui est le nom de la colonne
    
    plt.plot(HAUTEUR_mFloat[1:]) # Création d'un graphique pour la hauteur des
    plt.show() # arbres :               Attention : bloquant 
   
    fichier.seek(0)
    print ('--2--')
# =============================================================================
# # Pour l'eleve faire afficher la circonférence la plus importante 
# # Attention memes problèmes que pour la hauteur    
#     fichier.seek(0) # Retour au début du fichier pour une nouvelle lecture 
#                       de celui-ci
#     for ligne2b in ObjLectureCSV : 
#          #print (ligne2b[12]) # Affichage d'une colonne en particulier (la circonférence en cm)
#         CIRCONFERENCEENCM.append(ligne2b[12]) # Création d'une liste avec la circonférence de tous les arbres
#     print ("L'arbre le plus large mesure " + str(max(CIRCONFERENCEENCM[1:]) + ' centimètres de circonférence')) # Prise en compte de la 
# #liste après le premier element qui est le nom de la colonne
#     print ('--2bis--')
# =============================================================================
    
# Affichage des arbres de type Platane dans le 6 ème arrondissement
# sur le boulevard Saint Germain 
    cptArbres = 0
    for ligne3 in ObjLectureCSV :
        if ligne3[9]=="Platanus" and ligne3[3]=="PARIS 6E ARRDT" \
        and ligne3[6]=="BOULEVARD SAINT GERMAIN":
            print (ligne3)
            cptArbres += 1
    print ("Le nombre de Platanes sur le Blv Saint Germain est",cptArbres )
    fichier.seek(0)
    print ('--3--')

# Nombre d'arbres remarquables dans Paris     
    compteurArbreRemarquable=0
    for ligne4 in ObjLectureCSV :
        if ligne4[15]=="1": # Attention ce n'est pas un nombre mais une chaine
            compteurArbreRemarquable+=1
    print ("Le nombre d'arbres remarquables dans Paris est :"\
           ,compteurArbreRemarquable) 
    fichier.seek(0)
    print ('--4--')
    
# Arbres remarquables dans le 6 ème arrondissement de Paris 
# Sauvegarde des données GPS dans une liste de position GPS

    positionGPSArbresRemarquables=[]        

    for ligne5 in ObjLectureCSV :
        if ligne5[15]=="1" and ligne5[3]=="PARIS 6E ARRDT": 
                print ("L'adresse et la position GPS de l'arbre sont :",\
                       ligne5[6],ligne5[16]) 
                positionGPSArbresRemarquables.append(ligne5[16]) # Ces données
                        # dont déjà au format chaines de caractères
    fichier.seek(0)
    print ('--5--')

# Affichage des informations relatives à la position GPS des arbres 
# du 6 ème arrondissement de Paris
    from geopy.geocoders import Nominatim
    geolocator = Nominatim(user_agent="XX") # Il faut placer une chaine de 
                                            # caractères quelconque   
    for i in range(0,len(positionGPSArbresRemarquables)):
        print(positionGPSArbresRemarquables[i])
        strLatLong=positionGPSArbresRemarquables[i]
         
        location = geolocator.reverse(strLatLong)
        print(location.address)

# Pour aller plus loin en autonomie
# Arbres remarquables dans le 5 ème arrondissement de Paris de type Robinia
# Sauvegarde des données GPS dans une liste de position GPS

    positionGPSPlusVieilArbreParis=[]        

    for ligne6 in ObjLectureCSV :
        if ligne6[15]=="1" and ligne6[3]=="PARIS 5E ARRDT" and \
        ligne6[9]=="Robinia": 
                print ("L'adresse et la position GPS de cet arbre est :",\
                       ligne6[6],ligne6[16]) 
                positionGPSPlusVieilArbreParis.append(ligne6[16]) # Ces données
                        # dont déjà au format chaines de caractères
    fichier.seek(0)
    print ('--6--')

# Affichage des informations relatives à la position GPS des arbres 
# du 6 ème arrondissement de Paris
    from geopy.geocoders import Nominatim
    geolocator = Nominatim(user_agent="XX") # Il faut placer une chaine de 
                                            # caractères quelconque   
    for i in range(0,len(positionGPSPlusVieilArbreParis)):
        print(positionGPSPlusVieilArbreParis[i])
        strLatLong=positionGPSPlusVieilArbreParis[i]
         
        location = geolocator.reverse(strLatLong)
        print(location.address)

            
#     fichier.close() # Fermeture du fichier Cette ligne doit être inutile
#                       grace à la structure with

input ()
print ('fini')